summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorEric Blake <eblake@redhat.com>2010-09-30 16:31:50 -0600
committerEric Blake <eblake@redhat.com>2010-10-01 10:43:25 -0600
commitabe5c1f9bc09753fd79e7a121c8ecfa917dfaddb (patch)
treec12acdcacbb247f0a12c518c1c5529ac6b989f19 /tests
parent1129cb58bae34419e1b8bebbe1bb0a7ec9a9cca7 (diff)
downloadcoreutils-abe5c1f9bc09753fd79e7a121c8ecfa917dfaddb.tar.xz
stat: support printing birthtime
* src/stat.c (print_stat): New %w and %W formats. (do_stat): Include %w in default format. (usage): Document new specifiers. * doc/coreutils.texi (stat invocation): Likewise. * NEWS: Likewise.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/misc/stat-birthtime41
2 files changed, 42 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 3236637c6..a6a0594b8 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -239,6 +239,7 @@ TESTS = \
misc/split-a \
misc/split-fail \
misc/split-l \
+ misc/stat-birthtime \
misc/stat-fmt \
misc/stat-hyphen \
misc/stat-mount \
diff --git a/tests/misc/stat-birthtime b/tests/misc/stat-birthtime
new file mode 100755
index 000000000..b54268c11
--- /dev/null
+++ b/tests/misc/stat-birthtime
@@ -0,0 +1,41 @@
+#!/bin/sh
+# ensure that stat attempts birthtime access
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+
+# Whether birthtime is supported or not, it better not change even when
+# [acm]time are modified. :)
+touch a || fail=1
+btime=$(stat --format %W a) || fail=1
+atime=$(stat --format %X a) || fail=1
+mtime=$(stat --format %Y a) || fail=1
+ctime=$(stat --format %Z a) || fail=1
+
+case $(stat --format %x a) in
+ *.000000000*) sleep 2;; # worst case file system is FAT
+ *) # FIXME: sleep .1 would be sufficient if %X is fixed to show nanoseconds
+ sleep 1;;
+esac
+
+touch a || fail=1
+test "x$btime" = x$(stat --format %W a) || fail=1
+test "x$atime" != x$(stat --format %X a) || fail=1
+test "x$mtime" != x$(stat --format %Y a) || fail=1
+test "x$ctime" != x$(stat --format %Z a) || fail=1
+
+Exit $fail